//+------------------------------------------------------------------+
//|                                                MartGreg v1.0.mq4 |
//|                                                              Alf |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Alf"
#property link      "---"

//---- input parameters
extern int       MACD1Fast=3;
extern int       MACD1Slow=5;
extern int       MACD2Fast=15;
extern int       MACD2Slow=22;
extern double    DML=3000;
extern int       UD=10;
extern int       StopLoss=84;
extern int       TakeProfit=100;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+

double Lot()
{
   double lt;
   double StartLot=MathFloor(AccountBalance()/DML)*0.01;
   if(StartLot==0)StartLot=0.01;
   double StopLot=NormalizeDouble(StartLot*MathPow(2,UD),1);
   if(OrdersHistoryTotal()==0) return (StartLot);
    bool o=true;
      for(int i=OrdersHistoryTotal()-1;i>=0;i--)
      {
        OrderSelect(i,SELECT_BY_POS,MODE_HISTORY);
        if(OrderType()==OP_BUY || OrderType()==OP_SELL)
        {
          o=false;
          break;
        }
      }
      if(o) return (StartLot);
      if(OrderProfit()<0)
      {
        lt=OrderLots()*1.6;
        if(lt>StopLot) return (StartLot);
        else return (lt);
      }
      
   return (StartLot);
}
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   if(Volume[0]>1) return;
   Print("OK");
   double m1,m2,m3,mm1,mm2;
   m1=iMACD(Symbol(),0,MACD1Fast,MACD1Slow,3,PRICE_MEDIAN,MODE_MAIN,1);
    m2=iMACD(Symbol(),0,MACD1Fast,MACD1Slow,3,PRICE_MEDIAN,MODE_MAIN,2);
     m3=iMACD(Symbol(),0,MACD1Fast,MACD1Slow,3,PRICE_MEDIAN,MODE_MAIN,3);
   mm1=iMACD(Symbol(),0,MACD2Fast,MACD2Slow,3,PRICE_MEDIAN,MODE_MAIN,1);
   mm2=iMACD(Symbol(),0,MACD2Fast,MACD2Slow,3,PRICE_MEDIAN,MODE_MAIN,2);
   double lot;
   if(OrdersTotal()==0)
   {
     if(m3>m2 && m2<m1 && mm1>mm2)
     {
         lot=Lot();
         Print("lot=",lot);
         OrderSend(Symbol(),OP_BUY,lot,Ask,3,Bid-StopLoss*Point,Ask+TakeProfit*Point);
     }
     if(m3<m2 && m2>m1 && mm1<mm2)
     {
      lot=Lot();
      
      Print("lot=",lot);
      OrderSend(Symbol(),OP_SELL,lot,Bid,3,Ask+StopLoss*Point,Bid-TakeProfit*Point);
     }
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+